
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>

#include "matrices.h"

float identidad[3][3] = {{1,0,0},{0,1,0},{0,0,1}};

void M_mkmatriz(float m[3][3],	float m00, float m01, float m02,
				float m10, float m11, float m12)
{
m[0][0]=m00;
m[0][1]=m01;
m[0][2]=m02;
m[1][0]=m10;
m[1][1]=m11;
m[1][2]=m12;
m[2][0]=0;
m[2][1]=0;
m[2][2]=1;
}
void M_print(float matriz[3][3])
{int i;
for (i=0; i<3; i++)
	printf("%f %f %f\n",matriz[i][0], matriz[i][1], matriz[i][2]);
printf("\n");
}

void M_copia(fuente,destino)
float fuente[3][3],destino[3][3];
{ int i,j;
for (i=0; i<3; i++) for (j=0; j<3; j++) destino[i][j]=fuente[i][j];
}

void M_multiplica(fuente,destino)
float fuente[3][3],destino[3][3];
{int i,j,k;
float suma;
float resultado[3][3];
for (i=0; i<3; i++)
	for (j=0; j<3; j++)
		{
		suma=0;
		for (k=0; k<3; k++)
			suma=suma+fuente[i][k]*destino[k][j];
		resultado[i][j]=suma;
		}
M_copia(resultado,fuente);
}

void M_translada(float fuente[3][3] , float x, float y)
{ int i,j;
float translacion[3][3];
M_copia(identidad, translacion);
translacion[0][2]=x;
translacion[1][2]=y;
M_multiplica(fuente,translacion);
}
    
void M_escala(float fuente[3][3] , float x, float y)
{ int i,j;
float escalado[3][3];
M_copia(identidad, escalado);
escalado[0][0]=x;
escalado[1][1]=y;
M_multiplica(fuente,escalado);
}

void M_rota(float fuente[3][3], float alfa)
{ int i,j;
float rotacion[3][3];
M_copia(identidad,rotacion);
rotacion[0][0]=cos(alfa);
rotacion[0][1]=-sin(alfa);
rotacion[1][0]=-rotacion[0][1];
rotacion[1][1]=rotacion[0][0];
M_multiplica(fuente,rotacion);
}

int M_tx(float matriz[3][3], float x, float y)
{ return (int)(matriz[0][0]*x+matriz[0][1]*y+matriz[0][2]);
}

int M_ty(float matriz[3][3],float x, float y)
{ return (int)(matriz[1][0]*x+matriz[1][1]*y+matriz[1][2]);
}

void M_moveto(float matriz[3][3], float x, float y)
{
moveto(M_tx(matriz,x,y),M_ty(matriz,x,y));
}

void M_lineto(float matriz[3][3], float x, float y)
{
lineto(M_tx(matriz,x,y),M_ty(matriz,x,y));
}

